﻿#Add-CollectionFromAD
#Written by Brian Kaler
#10/22/2018
#Description
#

$Scriptname = "Add-CollectionFromAD"
$SiteCode = "SSS" 
$SiteServer = "uswscm901.us.pinkertons.com" 
# Import the ConfigurationManager.psd1 module  
Import-Module "$($ENV:SMS_ADMIN_UI_PATH)\..\ConfigurationManager.psd1"  
# Set the current location to be the site code. 
Set-Location $SiteCode":\"  
#---------------edit the parameters first!
#as all CM functions need to be in the "SSS:\\" location we need to preserve a path to input files
$documentroot = "c:\users\bkaler!\documents"
#Name of the collection - also the name of the query rule and , used interchangably in script
#Format: TYPE-SHORTNAME-PACKAGEID
$collectionname = "APPPUSH-OFFICE365-SSS00096"
#AD Group name
$adgroupname = "APPPUSH-OFFICE365-SSS00096"
#laziness with variables
$collectiongroup = $collectionname
#All Servers with client installed
$limitingcollectionid = "SSS0005F"
#Provide the precise AD group name
$members = "PNKUS\\$collectionname"
#update this comment for description of the group!!!
$comment = "AutoGenerated by $Scriptname for $collectionname"



Function Add-CollectionFromAD(){
Param(
    [Parameter(Mandatory=$true)]
    [String]$collectionname,
    [Parameter(Mandatory=$true)]
    [String]$queryname,
    [Parameter(Mandatory=$true)]
    [String]$limitingcollectionid,
    [Parameter(Mandatory=$true)]
    [String]$adgroupname
    )

#get our default AD Group template and modify it accordingly
$querytemplate = (Get-CMQuery -name "Machines in AD Group XXX" | select -expandproperty Expression).Replace("YOURDOMAIN\\GROUPNAME",$adgroupname)

#create our query 
If(Get-cmquery -Name $queryname){
    Set-CMQuery -name $queryname -Expression $querytemplate -Comment $comment -LimitToCollectionId $limitingcollectionid
    $query = Get-cmquery -Name $queryname
    }
    else
    {
    $query = New-CMQuery -name $queryname -Comment $comment -LimitToCollectionId $limitingcollectionid -Expression $querytemplate
    }

#add the collection if it does already exist
If(Get-CMCollection -Name $collectionname){
    $collection = Get-CMCollection -Name $collectionname
    }
    Else
    {
    New-CMCollection -name $collectionname -CollectionType Device -LimitingCollectionid $limitingcollectionid -RefreshType Periodic -RefreshSchedule (Get-CMCollection -id $limitingcollectionid).RefreshSchedule[0] -Comment $comment
    $collection = Get-CMCollection -Name $collectionname
    }

#populate the collection
$expression = $query.expression
Add-CMDeviceCollectionQueryMembershipRule -Collection $collection -QueryExpression $expression -RuleName $queryname

}

Add-CollectionFromAd -collectionname $collectionname -queryname $collectionname -limitingcollectionid $limitingcollectionid -adgroupname $ADGROUPNAME